



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C#构造函数、私有构造函数、静态构造函数与构造函数执行顺序</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C#构造函数、私有构造函数、静态构造函数与构造函数执行顺序</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 02:52:50 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>默认构造函数</strong>，如果没有为类指定任何构造函数，编译器会自动为类创建一个无参构造函数，用以初始化类的字段；如果为类编写了构造函数，那么编译器就不会再自动生成无参构造函数了。ps.C#不允许用户为结构定义无参构造函数。</p>
<p><strong>静态构造函数</strong>，不能访问实例成员，只能用来初始化一些静态字段或者属性，仅在第一次调用类的任何成员时自动执行，不带访问修饰符，不带任何参数，每个类只能有一个静态构造函数，但可以同时还有一个无参实例构造函数，如下。</p>
<div>
<pre class="prettyprint linenums">public class Demo<br />
{<br />
    static Demo() { }<br />
    public Demo() { }<br />
}</pre>
</div>
<p><strong>私有构造函数</strong>，将构造函数申明为私有的，则不能通过new运算符在外部代码中实例化（但可以编写一个静态方法或属性在其内部实例化一个对象，再将结果返回给外部代码）。私有构造函数的作用：</p>
<ul><li>永远不会实例化，因为它仅用作某些静态成员的容器</li>
<li>希望类只能通过调用某个静态方法来实例化（即所谓的对象实例化的类工厂方法）</li></ul>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">    public class Demo<br />
    {<br />
        private Demo() { }<br />
        public static Demo NewDemo()<br />
        {<br />
            return new Demo();<br />
        }<br />
    }</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p><strong>构造函数执行顺序</strong>，通常情况下：构造函数先调用System.Object的构造函数，再按照继承的层次结构从上往下进行，直到最终要实例化的类为止，即最先调用的是基类的构造函数，但如果类有静态构造函数，且为首次调用该类，则先调用的是子类的静态构造函数，再是父类的静态构造函数，当然静态构造函数只会执行这一次，如下</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">//父类<br />
public class SuperClass<br />
{<br />
    static SuperClass()<br />
    {<br />
        Console.WriteLine("Super.Static");<br />
    }<br />
    public SuperClass()<br />
    {<br />
        Console.WriteLine("Super.Instance");<br />
    }<br />
}

//子类<br />
public class ChildClass : SuperClass<br />
{<br />
    static ChildClass()<br />
    {<br />
        Console.WriteLine("Child.Static");<br />
    }<br />
    public ChildClass()<br />
    {<br />
        Console.WriteLine("Child.Instance");<br />
    }<br />
}

//客户程序<br />
class Program<br />
{<br />
    static void Main(string[] args)<br />
    {<br />
        ChildClass cc = new ChildClass();<br />
        Console.ReadKey();<br />
    }<br />
}</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>输出结果为：</p>
<p>Child.Static</p>
<p>Super.Static</p>
<p>Super.Instance</p>
<p>Child.Instance</p>
<p>在不考了静态构造函数的情况下（因为静态构造仅执行一次，且定义静态构造函数的时候并不多），子类在调用父类的构造函数时，默认情况是调用父类的无参构造函数，如果父类只有带参构造函数，而没有无参构造函数，那么编译时会报错；不过我们可以通过base关键字来指定调用带参构造函数，如下</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">//父类<br />
public class SuperClass<br />
{<br />
    public SuperClass(string param)<br />
    {<br />
        Console.WriteLine("Super:" + param);<br />
    }<br />
}

//子类<br />
public class ChildClass : SuperClass<br />
{<br />
    public ChildClass(string param):base(param)<br />
    {<br />
        Console.WriteLine("Child:" + param);<br />
    }<br />
}

//客户程序<br />
class Program<br />
{<br />
    static void Main(string[] args)<br />
    {<br />
        ChildClass cc = new ChildClass("param");<br />
        Console.ReadKey();<br />
    }<br />
}</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>输出结果为</p>
<p>Super:param</p>
<p>Child:param</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2w2gwq.html">jmeter解决不同线程组之间传递参数问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rmved8.html">C风格字符串与C&plus;&plus;风格字符串</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok45we9.html">如何：通过对字符串应用 HTML 编码在 Web 应用程序中防止脚本侵入</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e131yz9.html">SelectionKey理解（总结）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1v3mgq.html">GPS定位开发</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg00yr8.html">自定义分页Gridview中Excel导出</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kjox09.html">WKWebView代理方法解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k2nv69.html">使用copy命令合并二进制文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z0j0j9.html">WordCount结对编程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9genwvl8.html">document&period;wrtie&lpar;&rpar;用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjjl759.html">xcodebuild构建时报错unknown error -1&equals;ffffffffffffffff Command &sol;bin&sol;sh failed with exit code 1</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25egzoq.html">绘图 Painter转接口封装的方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5polrq.html">opencv 基本使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m20xzrq.html">&lbrack;LeetCode&amp;amp&semi;Python&rsqb; Problem 830&period; Positions of Large Groups</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjw6m49.html">test-ipv6</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25706wq.html">CustomSqlSessionFactoryBean</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kop2k3q.html">灵书妙探第一季&sol;全集Castle迅雷下载</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx221pz8.html">BarTender连接不上数据库怎么办</a>
		</li>
						<li><a href="https://www.batexi.com/a/902enxnq.html">Jquery中&period;attr与&period;prop的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ko2lkjq.html">webpack快速入门&mdash;&mdash;打包后如何调试</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8kjvx3r9.html">解决Chrome 70版本以后谷歌不再信任赛门铁克证书问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j12w649.html">Linux系统时间同步方法小结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwzn279.html">以太坊客户端Geth命令用法-参数详解【转载】</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j12kze9.html">mac：Go安装和配置&plus;GoLand安装和使用之完整教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jkx43q.html">c 时间转移函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zy4mpv9.html">mac下安装mysql5&period;7&period;18，连接出现Access denied for user &amp;&num;39&semi;root&amp;&num;39&semi;&commat;&amp;&num;39&semi;localhost&amp;&num;39&semi; &lpar;using password&colon; YES&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pw3zo48.html">6 个开源的家庭自己主动化工具 &vert; Linux 中国</a>
			</li>
						<li><a href="https://www.batexi.com/a/93w7xxgq.html">Tomcat启动报错：This file is needed to run this program</a>
			</li>
						<li><a href="https://www.batexi.com/a/960d0wy9.html">lis最长上升子序列</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1ydnlq.html">【漏洞复现】Tomcat CVE-2017-12615 远程代码执行漏洞</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
